<?php
require_once './inc/nusoap.php' ;

function google_get_res($q,$start) {
	global $GOOGLE_KEY ;

	if (!$GOOGLE_KEY) return '' ;

	$cachefile = "cache/G_" . md5($q) ;
	$cachetime = 60*60*12; // 12 hours
	// Serve from the cache if it is younger than $cachetime
	if (file_exists($cachefile) && (time() - $cachetime < filemtime($cachefile))) {
        	$ret = file_get_contents($cachefile);
	} else {
		$ret = _google_get_res($q,0) ;
		$fp = fopen($cachefile, 'w');
        	fwrite($fp,$ret);
        	fclose($fp);
	}
	return $ret ;
}

function _google_get_res($q,$start) {
	global $GOOGLE_KEY ;
	$soapclient = new soapclient("http://api.google.com/search/beta2");
	// $soapclient->debug_flag = 1;
	$params = array(
		'key' => $GOOGLE_KEY,
		'q'   => $q,
		'start' => $start,
		'maxResults' => 10,
		'filter' => true,
		'restrict' => '',
		'safeSearch' => false,
		'lr' => '',
		'ie' => 'utf-8',
		'oe' => 'utf-8'
	);
	$result = $soapclient->call("doGoogleSearch", $params, "urn:GoogleSearch", "urn:GoogleSearch"); 
	if ($result['faultstring']) {
		// uncomment to debug! return $result['faultstring'] ;
		return "" ;
	} else {
		$searchtime = $result["searchTime"];
		$begin = $start + 1;
		$end = $start + $params["maxResults"];
		$total = $result["estimatedTotalResultsCount"]; 

    		$result = $result["resultElements"]; 

		$ret = "<div class=\"google\">" ;
		$ret .= "<img src=\"i/google.gif\" alt=\"google\" align=\"middle\" /> results for \"$q\" "  ;
		$ret .= "(" . count($result) . " of " . number_format($total,0,'.',',') . ")" ;
		$ret .= "<div class=\"google_res\"> " ;

    		for ($i = 0; $i<count($result); $i++)
    		{
			$c=$start+$i+1 ;
        		$element = $result[$i];
			$url = $element['URL'] ;

        		$cachedSize = $element['cachedSize'] ;
        		$title = $element['title'] ;
        		if (!$title) $title=$url ;
        		$snippet = str_replace('<p>','',$element['snippet']) ;
        		$snippet = str_replace('</p>','',$snippet) ;
        		$snippet = str_replace('<br>','',$snippet) ;
        		$summary = $element['summary'] ;
        		$ret .= "<p><a href=\"$url\" style=\"color: #0000cc\">$title</a>&nbsp;" ;
        		$ret .= "$snippet " ;
        		$ret .= "<span style=\"color: #008000;\">" . htmlentities($url) ."  -  $cachedSize </span> \n" ;
        		$ret .= "</p>\n" ;

    		}

		$ret .= "</div>\n" ;
		$ret .= "</div>\n" ;
	}
	return $ret ;
}
?>
